import {FC} from 'react';
import Filter from './filter';
import {ChildrenFC} from '@utils';
import {context, pageContext, searchContext, useContextReducer} from './context';
import TableList from './table';
import {PageProvider, SearchProvider} from '@components';

const RoleProvider: ChildrenFC = function({children}) {
  const state = useContextReducer();
  const {Provider} = context;

  return <Provider value={state}>{children}</Provider>;
};

const Role: FC = function() {
  return (
    <RoleProvider>
      <SearchProvider context={searchContext}>
        <PageProvider context={pageContext}>
          <section className='content-main'>
            <Filter />
            <TableList />
          </section>
        </PageProvider>
      </SearchProvider>
    </RoleProvider>
  );
};

export default Role;
